#!/usr/bin/perl -w
use strict;
BEGIN {
	unshift @INC,"/nfs/users/nfs_z/zn1/phusion_pipeline/Perl_scripts/";
}
use RP;

my($N) = "NNNNNNNNNNNNNNNNNNNNNNNNN";
$N = $N.$N.$N.$N;
$N = $N.$N.$N.$N.$N.$N.$N.$N.$N.$N;
$N = $N.$N.$N.$N.$N.$N.$N.$N.$N.$N; #10000 N's
$N = $N.$N.$N.$N.$N.$N.$N.$N.$N.$N; #100000 N's
$N = $N.$N.$N.$N.$N.$N.$N.$N.$N.$N; #1000000 N's
$N = $N.$N.$N.$N.$N.$N.$N.$N.$N.$N; #10000000 N's
$N = $N.$N.$N.$N.$N.$N.$N.$N.$N.$N; #100000000 N's
my($Q) = "!!!!!!!!!!!!!!!!!!!!!!!!!";
$Q = $Q.$Q.$Q.$Q;
$Q = $Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q; #1000 0's
$Q = $Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q; #10000 0's
$Q = $Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q; #100000 0's
$Q = $Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q; #1000000 0's
$Q = $Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q; #10000000 0's
$Q = $Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q.$Q; #100000000 0's


my(%bases, %quals) = ();
readFQ($ARGV[0]);
my $osc = "";
my $q = "";
my $b = "";
my $fname = $ARGV[1];
open F,$fname;
while (<F>) {
	chomp;
	if(/^supercontig\s+(\S+)/) {
		my $scontig = $1;
		if($scontig ne $osc) {
			if($osc ne "") {
				print "\@$osc\n$b\n\+$osc\n$q\n";
				$b = "";
				$q = "";
			}
		}
		$osc = $scontig;
	} elsif (/^gap\s+(-?\d+)\s+/) {
		my $gs = $1;
		$gs = 10 if $gs < 10;
		$b .= substr($N,0,$gs);
		$q .= substr($Q,0,$gs);
	} elsif (/^contig\s+(\S+)/) {
		my $contig = $1;
		$b .= $bases{$contig};
		$q .= $quals{$contig};
	}
}
print "\@$osc\n$b\n\+$osc\n$q\n";

sub rcfastq {
	my ($b,$q) = @_;
	my (@quals) = unpack("C*",$q);
	$quals[-1] = 041;
	$q = pack("C*",reverse(@quals));
	my (@bases) = unpack("C*",$b);
	$b = pack("C*",reverse(@bases));
	$b =~ s/a/1/g;
	$b =~ s/c/2/g;
	$b =~ s/g/3/g;
	$b =~ s/t/4/g;
	$b =~ s/A/5/g;
	$b =~ s/C/6/g;
	$b =~ s/G/7/g;
	$b =~ s/T/8/g;
	$b =~ s/1/t/g;
	$b =~ s/2/g/g;
	$b =~ s/3/c/g;
	$b =~ s/4/a/g;
	$b =~ s/5/T/g;
	$b =~ s/6/G/g;
	$b =~ s/7/C/g;
	$b =~ s/8/A/g;
	return ($b, $q);
}

sub readFQ {
	my ($qname) = @_;
	return() if !defined($qname);
	open G,$qname or die "cannot open $qname\n";
	while(my $line = <G>) {
		if($line =~ /^\@(\S+)/) {
			my ($read) = $1;
			$read =~ s/\-\d+$//;
			$bases{$read} = <G>;
			chomp $bases{$read};
			$line = <G>;
			$quals{$read} = <G>;
			chomp $quals{$read};
		}
	}
	close G;
}
